#pragma once
#include <Windows.h>
#include <dxgi1_2.h>

class Window
{
public:
    Window(ID3D11Device* device, int width, int height);
    ~Window() = default;

    HWND getHandle() const { return m_handle; }

    bool runEventLoop() const;

    Microsoft::WRL::ComPtr<ID3D11RenderTargetView> backBufferRtv() const { return m_renderTargetView; };

private:
    void createSwapChain();

    HWND m_handle;
    int m_width{};
    int m_height{};
    Microsoft::WRL::ComPtr<IDXGISwapChain1> m_swapChain;
    Microsoft::WRL::ComPtr<ID3D11Device> m_device;
    Microsoft::WRL::ComPtr<ID3D11RenderTargetView> m_renderTargetView;
    D3D11_TEXTURE2D_DESC m_backBufferDesc;
};
